searchNodes=[{"ref":"Floki.html","title":"Floki","type":"module","doc":"Floki is a simple HTML parser that enables search for nodes using CSS selectors. Example Assuming that you have the following HTML: &lt;!doctype html&gt; &lt;html&gt; &lt;body&gt; &lt;section id=&quot;content&quot;&gt; &lt;p class=&quot;headline&quot;&gt;Floki&lt;/p&gt; &lt;a href=&quot;http://github.com/philss/floki&quot;&gt;Github page&lt;/a&gt; &lt;span data-model=&quot;user&quot;&gt;philss&lt;/span&gt; &lt;/section&gt; &lt;/body&gt; &lt;/html&gt; Examples of queries that you can perform: Floki.find(html, &quot;#content&quot;) Floki.find(html, &quot;.headline&quot;) Floki.find(html, &quot;a&quot;) Floki.find(html, &quot;[data-model=user]&quot;) Floki.find(html, &quot;#content a&quot;) Floki.find(html, &quot;.headline, a&quot;) Each HTML node is represented by a tuple like: {tag_name, attributes, children_nodes} Example of node: {&quot;p&quot;, [{&quot;class&quot;, &quot;headline&quot;}], [&quot;Floki&quot;]} So even if the only child node is the element text, it is represented inside a list. You can write a simple HTML crawler (with support of HTTPoison) with a few lines of code: html |&gt; Floki.find(&quot;.pages a&quot;) |&gt; Floki.attribute(&quot;href&quot;) |&gt; Enum.map(fn(url) -&gt; HTTPoison.get!(url) end) It is simple as that!"},{"ref":"Floki.html#attr/4","title":"Floki.attr/4","type":"function","doc":"Changes the attribute values of the elements matched by selector with the function mutation and returns the whole element tree Examples iex&gt; Floki.attr(&quot;&lt;div id=&#39;a&#39;&gt;&lt;/div&gt;&quot;, &quot;#a&quot;, &quot;id&quot;, fn(id) -&gt; String.replace(id, &quot;a&quot;, &quot;b&quot;) end) [{&quot;div&quot;, [{&quot;id&quot;, &quot;b&quot;}], []}] iex&gt; Floki.attr(&quot;&lt;div class=&#39;class_name&#39;&gt;&lt;/div&gt;&quot;, &quot;div&quot;, &quot;id&quot;, fn _ -&gt; &quot;b&quot; end) [{&quot;div&quot;, [{&quot;id&quot;, &quot;b&quot;}, {&quot;class&quot;, &quot;class_name&quot;}], []}]"},{"ref":"Floki.html#attribute/2","title":"Floki.attribute/2","type":"function","doc":"Returns a list with attribute values from elements. Examples iex&gt; Floki.attribute(&quot;&lt;a href=https://google.com&gt;Google&lt;/a&gt;&quot;, &quot;href&quot;) [&quot;https://google.com&quot;] iex&gt; Floki.attribute([{&quot;a&quot;, [{&quot;href&quot;, &quot;https://google.com&quot;}], [&quot;Google&quot;]}], &quot;href&quot;) [&quot;https://google.com&quot;]"},{"ref":"Floki.html#attribute/3","title":"Floki.attribute/3","type":"function","doc":"Returns a list with attribute values for a given selector. Examples iex&gt; Floki.attribute(&quot;&lt;a href=&#39;https://google.com&#39;&gt;Google&lt;/a&gt;&quot;, &quot;a&quot;, &quot;href&quot;) [&quot;https://google.com&quot;] iex&gt; Floki.attribute([{&quot;a&quot;, [{&quot;href&quot;, &quot;https://google.com&quot;}], [&quot;Google&quot;]}], &quot;a&quot;, &quot;href&quot;) [&quot;https://google.com&quot;]"},{"ref":"Floki.html#children/2","title":"Floki.children/2","type":"function","doc":"Returns the direct child nodes of a HTML tree. By default, it will also include all texts. You can disable this behaviour by using the option include_text to false Examples iex&gt; Floki.children({&quot;div&quot;, [], [&quot;text&quot;, {&quot;span&quot;, [], []}]}) [&quot;text&quot;, {&quot;span&quot;, [], []}] iex&gt; Floki.children({&quot;div&quot;, [], [&quot;text&quot;, {&quot;span&quot;, [], []}]}, include_text: false) [{&quot;span&quot;, [], []}]"},{"ref":"Floki.html#filter_out/2","title":"Floki.filter_out/2","type":"function","doc":"Returns the nodes from a HTML tree that don&#39;t match the filter selector. Examples iex&gt; Floki.filter_out(&quot;&lt;div&gt;&lt;script&gt;hello&lt;/script&gt; world&lt;/div&gt;&quot;, &quot;script&quot;) {&quot;div&quot;, [], [&quot; world&quot;]} iex&gt; Floki.filter_out([{&quot;body&quot;, [], [{&quot;script&quot;, [], []},{&quot;div&quot;, [], []}]}], &quot;script&quot;) [{&quot;body&quot;, [], [{&quot;div&quot;, [], []}]}] iex&gt; Floki.filter_out(&quot;&lt;div&gt;&lt;!-- comment --&gt; text&lt;/div&gt;&quot;, :comment) {&quot;div&quot;, [], [&quot; text&quot;]}"},{"ref":"Floki.html#find/2","title":"Floki.find/2","type":"function","doc":"Find elements inside a HTML tree or string. Examples iex&gt; Floki.find(&quot;&lt;p&gt;&lt;span class=hint&gt;hello&lt;/span&gt;&lt;/p&gt;&quot;, &quot;.hint&quot;) [{&quot;span&quot;, [{&quot;class&quot;, &quot;hint&quot;}], [&quot;hello&quot;]}] iex&gt; Floki.find(&quot;&lt;body&gt;&lt;div id=important&gt;&lt;div&gt;Content&lt;/div&gt;&lt;/div&gt;&lt;/body&gt;&quot;, &quot;#important&quot;) [{&quot;div&quot;, [{&quot;id&quot;, &quot;important&quot;}], [{&quot;div&quot;, [], [&quot;Content&quot;]}]}] iex&gt; Floki.find(&quot;&lt;p&gt;&lt;a href=&#39;https://google.com&#39;&gt;Google&lt;/a&gt;&lt;/p&gt;&quot;, &quot;a&quot;) [{&quot;a&quot;, [{&quot;href&quot;, &quot;https://google.com&quot;}], [&quot;Google&quot;]}] iex&gt; Floki.find([{ &quot;div&quot;, [], [{&quot;a&quot;, [{&quot;href&quot;, &quot;https://google.com&quot;}], [&quot;Google&quot;]}]}], &quot;div a&quot;) [{&quot;a&quot;, [{&quot;href&quot;, &quot;https://google.com&quot;}], [&quot;Google&quot;]}]"},{"ref":"Floki.html#map/2","title":"Floki.map/2","type":"function","doc":"It receives a HTML tree structure as tuple and maps through all nodes with a given function that receives a tuple with {name, attributes}. It returns that structure transformed by the function. Examples iex&gt; html = {&quot;div&quot;, [{&quot;class&quot;, &quot;foo&quot;}], [&quot;text&quot;]} iex&gt; Floki.map(html, fn({name, attrs}) -&gt; {name, [{&quot;data-name&quot;, &quot;bar&quot;} | attrs]} end) {&quot;div&quot;, [{&quot;data-name&quot;, &quot;bar&quot;}, {&quot;class&quot;, &quot;foo&quot;}], [&quot;text&quot;]}"},{"ref":"Floki.html#parse/1","title":"Floki.parse/1","type":"function","doc":"Parses a HTML string. Examples iex&gt; Floki.parse(&quot;&lt;div class=js-action&gt;hello world&lt;/div&gt;&quot;) {&quot;div&quot;, [{&quot;class&quot;, &quot;js-action&quot;}], [&quot;hello world&quot;]} iex&gt; Floki.parse(&quot;&lt;div&gt;first&lt;/div&gt;&lt;div&gt;second&lt;/div&gt;&quot;) [{&quot;div&quot;, [], [&quot;first&quot;]}, {&quot;div&quot;, [], [&quot;second&quot;]}]"},{"ref":"Floki.html#raw_html/2","title":"Floki.raw_html/2","type":"function","doc":"Converts HTML tree to raw HTML. Note that the resultant HTML may be different from the original one. Spaces after tags and doctypes are ignored. Floki.raw_html/2 accepts a keyword list of options. Currently, the only supported option is :encode, which can be set to true or false. You can also control the encoding behaviour at the application level via config :floki, :encode_raw_html, true | false Examples iex&gt; Floki.parse(~s(&lt;div class=&quot;wrapper&quot;&gt;my content&lt;/div&gt;)) |&gt; Floki.raw_html ~s(&lt;div class=&quot;wrapper&quot;&gt;my content&lt;/div&gt;) iex&gt; Floki.parse(~s(&lt;div class=&quot;wrapper&quot;&gt;10 &gt; 5&lt;/div&gt;)) |&gt; Floki.raw_html(encode: true) ~s(&lt;div class=&quot;wrapper&quot;&gt;10 &amp;gt; 5&lt;/div&gt;) iex&gt; Floki.parse(~s(&lt;div class=&quot;wrapper&quot;&gt;10 &gt; 5&lt;/div&gt;)) |&gt; Floki.raw_html(encode: false) ~s(&lt;div class=&quot;wrapper&quot;&gt;10 &gt; 5&lt;/div&gt;)"},{"ref":"Floki.html#text/2","title":"Floki.text/2","type":"function","doc":"Returns the text nodes from a HTML tree. By default, it will perform a deep search through the HTML tree. You can disable deep search with the option deep assigned to false. You can include content of script tags with the option js assigned to true. You can specify a separator between nodes content. Examples iex&gt; Floki.text(&quot;&lt;div&gt;&lt;span&gt;hello&lt;/span&gt; world&lt;/div&gt;&quot;) &quot;hello world&quot; iex&gt; Floki.text(&quot;&lt;div&gt;&lt;span&gt;hello&lt;/span&gt; world&lt;/div&gt;&quot;, deep: false) &quot; world&quot; iex&gt; Floki.text(&quot;&lt;div&gt;&lt;script&gt;hello&lt;/script&gt; world&lt;/div&gt;&quot;) &quot; world&quot; iex&gt; Floki.text(&quot;&lt;div&gt;&lt;script&gt;hello&lt;/script&gt; world&lt;/div&gt;&quot;, js: true) &quot;hello world&quot; iex&gt; Floki.text(&quot;&lt;ul&gt;&lt;li&gt;hello&lt;/li&gt;&lt;li&gt;world&lt;/li&gt;&lt;/ul&gt;&quot;, sep: &quot; &quot;) &quot;hello world&quot; iex&gt; Floki.text([{&quot;div&quot;, [], [&quot;hello world&quot;]}]) &quot;hello world&quot; iex&gt; Floki.text([{&quot;p&quot;, [], [&quot;1&quot;]},{&quot;p&quot;, [], [&quot;2&quot;]}]) &quot;12&quot; iex&gt; Floki.text(&quot;&lt;div&gt;&lt;style&gt;hello&lt;/style&gt; world&lt;/div&gt;&quot;) &quot;hello world&quot; iex&gt; Floki.text(&quot;&lt;div&gt;&lt;style&gt;hello&lt;/style&gt; world&lt;/div&gt;&quot;, style: false) &quot; world&quot;"},{"ref":"Floki.html#traverse_and_update/2","title":"Floki.traverse_and_update/2","type":"function","doc":"Traverses a HTML tree structure and returns a new tree structure that is the result of executing a function on all nodes. The function receives a tuple with {name, attributes, children}, and should either return a similar tuple or nil to delete the current node. Examples iex&gt; html = {&quot;div&quot;, [], [&quot;hello&quot;]} iex&gt; Floki.traverse_and_update(html, fn {&quot;div&quot;, attrs, children} -&gt; {&quot;p&quot;, attrs, children} end) {&quot;p&quot;, [], [&quot;hello&quot;]} iex&gt; html = {&quot;div&quot;, [], [{&quot;span&quot;, [], [&quot;hello&quot;]}]} iex&gt; Floki.traverse_and_update(html, fn {&quot;span&quot;, _attrs, _children} -&gt; nil; tag -&gt; tag end) {&quot;div&quot;, [], []}"},{"ref":"Floki.html#t:html_tree/0","title":"Floki.html_tree/0","type":"type","doc":""},{"ref":"readme.html","title":"README","type":"extras","doc":"Floki is a simple HTML parser that enables search for nodes using CSS selectors. Check the documentation."},{"ref":"readme.html#usage","title":"README - Usage","type":"extras","doc":"Take this HTML as an example: &lt;!doctype html&gt; &lt;html&gt; &lt;body&gt; &lt;section id=&quot;content&quot;&gt; &lt;p class=&quot;headline&quot;&gt;Floki&lt;/p&gt; &lt;span class=&quot;headline&quot;&gt;Enables search using CSS selectors&lt;/span&gt; &lt;a href=&quot;https://github.com/philss/floki&quot;&gt;Github page&lt;/a&gt; &lt;span data-model=&quot;user&quot;&gt;philss&lt;/span&gt; &lt;/section&gt; &lt;a href=&quot;https://hex.pm/packages/floki&quot;&gt;Hex package&lt;/a&gt; &lt;/body&gt; &lt;/html&gt; Here are some queries that you can perform (with return examples): Floki.find(html, &quot;p.headline&quot;) # =&gt; [{&quot;p&quot;, [{&quot;class&quot;, &quot;headline&quot;}], [&quot;Floki&quot;]}] Floki.find(html, &quot;p.headline&quot;) |&gt; Floki.raw_html # =&gt; &lt;p class=&quot;headline&quot;&gt;Floki&lt;/p&gt; Each HTML node is represented by a tuple like: {tag_name, attributes, children_nodes} Example of node: {&quot;p&quot;, [{&quot;class&quot;, &quot;headline&quot;}], [&quot;Floki&quot;]} So even if the only child node is the element text, it is represented inside a list. You can write a simple HTML crawler with Floki and HTTPoison: html |&gt; Floki.find(&quot;.pages a&quot;) |&gt; Floki.attribute(&quot;href&quot;) |&gt; Enum.map(fn(url) -&gt; HTTPoison.get!(url) end) It is simple as that!"},{"ref":"readme.html#installation","title":"README - Installation","type":"extras","doc":"Add Floki to your mix.exs: defp deps do [ {:floki, &quot;~&gt; 0.23.0&quot;} ] end After that, run mix deps.get."},{"ref":"readme.html#dependencies","title":"README - Dependencies","type":"extras","doc":"Floki needs the leex module in order to compile. Normally this module is installed with Erlang in a complete installation. If you get this kind of error, you need to install the erlang-dev and erlang-parsetools packages in order get the leex module. The packages names may be different depending on your OS. Optional - Using html5ever as the HTML parser You can configure Floki to use html5ever as your HTML parser. This is recommended if you need better performance and a more accurate parser. However html5ever is being under active development and may be unstable. Since it&#39;s written in Rust, we need to install Rust and compile the project. Luckily we have the html5ever Elixir NIF that makes the integration very easy. You still need to install Rust in your system. To do that, please follow the instruction presented in the official page. Installing html5ever After setup Rust, you need to add html5ever NIF to your dependency list: defp deps do [ {:floki, &quot;~&gt; 0.23.0&quot;}, {:html5ever, &quot;~&gt; 0.7.0&quot;} ] end Run mix deps.get and compiles the project with mix compile to make sure it works. Then you need to configure your app to use html5ever: # in config/config.exs config :floki, :html_parser, Floki.HTMLParser.Html5ever After that you are able to use html5ever as your HTML parser with Floki. For more info, check the article Rustler - Safe Erlang and Elixir NIFs in Rust."},{"ref":"readme.html#more-about-floki-api","title":"README - More about Floki API","type":"extras","doc":"To parse a HTML document, try: html = &quot;&quot;&quot; &lt;html&gt; &lt;body&gt; &lt;div class=&quot;example&quot;&gt;&lt;/div&gt; &lt;/body&gt; &lt;/html&gt; &quot;&quot;&quot; Floki.parse(html) # =&gt; {&quot;html&quot;, [], [{&quot;body&quot;, [], [{&quot;div&quot;, [{&quot;class&quot;, &quot;example&quot;}], []}]}]} To find elements with the class example, try: Floki.find(html, &quot;.example&quot;) # =&gt; [{&quot;div&quot;, [{&quot;class&quot;, &quot;example&quot;}], []}] To convert your node tree back to raw HTML (spaces are ignored): Floki.find(html, &quot;.example&quot;) |&gt; Floki.raw_html # =&gt; &lt;div class=&quot;example&quot;&gt;&lt;/div&gt; To fetch some attribute from elements, try: Floki.attribute(html, &quot;.example&quot;, &quot;class&quot;) # =&gt; [&quot;example&quot;] You can get attributes from elements that you already have: Floki.find(html, &quot;.example&quot;) |&gt; Floki.attribute(&quot;class&quot;) # =&gt; [&quot;example&quot;] If you want to get the text from an element, try: Floki.find(html, &quot;.headline&quot;) |&gt; Floki.text # =&gt; &quot;Floki&quot;"},{"ref":"readme.html#supported-selectors","title":"README - Supported selectors","type":"extras","doc":"Here you find all the CSS selectors supported in the current version: PatternDescription *any element Ean element of type E E[foo]an E element with a &quot;foo&quot; attribute E[foo=&quot;bar&quot;]an E element whose &quot;foo&quot; attribute value is exactly equal to &quot;bar&quot; E[foo~=&quot;bar&quot;]an E element whose &quot;foo&quot; attribute value is a list of whitespace-separated values, one of which is exactly equal to &quot;bar&quot; E[foo^=&quot;bar&quot;]an E element whose &quot;foo&quot; attribute value begins exactly with the string &quot;bar&quot; E[foo$=&quot;bar&quot;]an E element whose &quot;foo&quot; attribute value ends exactly with the string &quot;bar&quot; E[foo*=&quot;bar&quot;]an E element whose &quot;foo&quot; attribute value contains the substring &quot;bar&quot; E[foo|=&quot;en&quot;]an E element whose &quot;foo&quot; attribute has a hyphen-separated list of values beginning (from the left) with &quot;en&quot; E:nth-child(n)an E element, the n-th child of its parent E:first-childan E element, first child of its parent E:last-childan E element, last child of its parent E:nth-of-type(n)an E element, the n-th child of its type among its siblings E:first-of-typean E element, first child of its type among its siblings E:last-of-typean E element, last child of its type among its siblings E.warningan E element whose class is &quot;warning&quot; E#myidan E element with ID equal to &quot;myid&quot; E:not(s)an E element that does not match simple selector s E Fan F element descendant of an E element E &gt; Fan F element child of an E element E + Fan F element immediately preceded by an E element E ~ Fan F element preceded by an E element There are also some selectors based on non-standard specifications. They are: PatternDescription E:fl-contains(&#39;foo&#39;)an E element that contains &quot;foo&quot; inside a text node"},{"ref":"readme.html#special-thanks","title":"README - Special thanks","type":"extras","doc":"@arasatasaygin for Floki&#39;s logo from the Open Logos project."},{"ref":"readme.html#license","title":"README - License","type":"extras","doc":"Floki is under MIT license. Check the LICENSE file for more details."}]